﻿using System;
using System.Net.Http;
using System.Threading.Tasks;

namespace CreateLearnerExample.Services.V1
{
    public class AuthenticationService
    {
        private HttpClient _client;

        public AuthenticationService(HttpClient client)
        {
            _client = client;
        }

        public async Task<Guid> Authenticate(Guid customerToken)
        {
            _client.DefaultRequestHeaders.Clear();
            _client.DefaultRequestHeaders.Add("X-CustomerToken", customerToken.ToString());
            _client.DefaultRequestHeaders.TryAddWithoutValidation("Content-Type", "application/json; charset=utf-8");


            HttpResponseMessage response = await _client.PostAsync($"{Program.HOST}/api/v1/Authentication/Authenticate", null);

            if (response.IsSuccessStatusCode)
            {
                string responseMessage = await response.Content.ReadAsStringAsync();
                responseMessage = responseMessage.Replace("\"", "");

                if (Guid.TryParse(responseMessage, out Guid sessionId))
                {
                    return sessionId;
                }
            }
            throw new UnauthorizedAccessException("Invalid customer token");
        }
    }
}
