﻿using System;
using System.Net.Http;
using System.Threading.Tasks;

namespace CreateLearnerExample.Services.V2
{
    public class AuthenticationServiceV2
    {
        private readonly HttpClient _client;

        public AuthenticationServiceV2(HttpClient httpClient)
        {
            _client = httpClient;
        }

        public string Authenticate(Guid customerToken)
        {
            string token = string.Empty;

            _client.DefaultRequestHeaders.Add("X-CustomerToken", customerToken.ToString());

            HttpResponseMessage response = _client.PostAsync($"{Program.HOST}/api/v2/Authentication", null).Result;

            string responseContent = response.Content.ReadAsStringAsync().Result;
            if (response.IsSuccessStatusCode)
            {
                return responseContent;
            }

            throw new Exception($"Unable to authenticate - {response.StatusCode}");
        }


    }
}
