﻿using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using CreateLearnerExample.Models;
using Newtonsoft.Json;

namespace CreateLearnerExample.Services.V2
{
    public class UserServiceV2
    {
        private HttpClient _client;

        public UserServiceV2(HttpClient client)
        {
            _client = client;
        }

        /// <summary>
        ///  -- Required Parameters --
        /// OrganisationID - INT,  ClassroomID - INT, Email - string, Firstname - string, lastname - string, placementID - int, Role - (1 = Learner, 5 = Assessor)
        /// </summary>
        /// <param name="authToken"></param>
        /// <param name="learner"></param>
        /// <returns></returns>
        public async Task<User> CreateUser(string authToken, User user)
        {
            _client.DefaultRequestHeaders.Clear();
            _client.DefaultRequestHeaders.Add("x-TokenID", authToken);

            using (HttpResponseMessage response = _client.PostAsync($"{Program.HOST}/api/v2/User", new StringContent(JsonConvert.SerializeObject(user), Encoding.UTF8, "application/json")).Result)
            {
                return JsonConvert.DeserializeObject<User>(await response.Content.ReadAsStringAsync());
            }
        }
    }
}
